<template>
  <checkauto-layout>
    <AppBreadcrumbs
      slot="line-breadcrumb"
      :breadcrumbs="breadcrumbs"/>

    <div
      slot="line-content"
      class="kit outer">
      <div class="kit view checkauto report">
        <div class="top">
          <div class="sticky-button-wrap mobilshow">
            <div class="text">
              <span class="mobilshow">Полный отчет</span>
              <span>{{ servicePrice }}</span>
            </div>
            <a
              role="button"
              class="ui button m-mini circular yellow"
              @click="showPurchase">
              <span>Купить<span class="mobilshow hidden md"> полный отчет</span></span>
            </a>
          </div>
          <div class="heading">
            <h1>Отчёт проверки авто
              <span class="vin-wrap">по VIN {{ info.Vin }}</span>
            </h1>
            <div class="date-wrap">Дата проверки: {{ dateNow }}</div>
          </div>
          <div class="top-button-wrap">
            <div class="text">
              <span class="desktopshow">Стоимость полного отчета:</span>
              <span class="mobilshow">Полный отчет</span>
              <span
                v-if="billing.checkauto.promocode"
                :data-strike-text="billing.checkauto.promocode.price"
                class="kit strike-text">{{ servicePrice }}</span>
              <span v-else>{{ servicePrice }}</span>
            </div>
            <a
              role="button"
              class="ui button circular yellow"
              @click="showPurchase">
              <span>Купить</span>
              <span class="mobilshow hidden md">полный отчет</span>
            </a>
          </div>
        </div>

        <report
          :info="info"
          :full="false"
          :promo="!auth && billing.checkauto.promocode === null"
          @show-purchase="showPurchase"/>

        <div class="bottom">
          <div class="flexline">
            <p>Стоимость полного отчета:
              <span
                v-if="billing.checkauto.promocode"
                :data-strike-text="billing.checkauto.promocode.price"
                class="kit strike-text right">{{ servicePrice }}</span>
              <span v-else>{{ servicePrice }}</span>
            </p>
            <a
              role="button"
              class="ui button circular yellow"
              @click="showPurchase">
              <span>Купить<span class="hidden xs"> полный отчет</span></span>
            </a>
            <payment v-model="paymentSystem.code"/>
          </div>
        </div>
      </div>
    </div>

    <div slot="line-modal">
      <CheckAutoModal
        :visible="purchase.show"
        :width-modal="380"
        size="mini"
        name-modal="checkauto-purchase-modal"
        v-dom-move
        v-scroll-lock="purchase.show"
        @before-close="purchase.show = false"
        class="zIndex">
        <template slot="body">
          <i
            class="icon close"
            @click="hidePurchase"/>
          <div class="header default padding gray">
            <div class="title">Подтверждение покупки</div>
          </div>
          <div class="content-old">
            <div class="ui form">
              <div class="field">
                <label>Телефон</label>
                <phone-input
                  v-model="customer.phone"
                  placeholder="Введите телефон"
                  autofocus="autofocus"
                  :fluid="true"/>
              </div>
              <div class="field">
                <label>Email</label>
                <div class="ui input fluid icon">
                  <input
                    type="email"
                    v-model="rawEmail"
                    placeholder="Введите email">
                  <i
                    class="link advanced icon remove"
                    v-erase-control="rawEmail"/>
                </div>
              </div>
              <div
                class="field"
                v-if="!auth && emailAvailable">
                <!--
                <div class="ui checkbox">
                  <input
                    type="checkbox"
                    id="registration"
                    v-model="customer.registration">
                  <label for="registration">Зарегистрироваться на gisauto.ru</label>
                </div>
                -->
                <AppCheckbox v-model="customer.registration">
                  <template #label>
                    Зарегистрироваться на gisauto.ru
                  </template>
                </AppCheckbox>
              </div>
              <div class="field">
                <!--
                <div class="ui checkbox">
                  <input
                    type="checkbox"
                    id="agreement"
                    v-model="customer.agreement">
                  <label for="agreement">
                    Согласен на
                    <a
                      target="_blank"
                      class="link"
                      href="/about-us/agreement">обработку персональных данных</a>
                  </label>
                </div>
                -->
                <AppCheckbox v-model="customer.agreement">
                  <template #label>
                    Согласен на
                    <flink
                      href="/about-us/agreement"
                      target="_blank"
                      class="link">обработку персональных данных</flink>.
                  </template>
                </AppCheckbox>
              </div>
              <template v-if="billing.checkauto.promocode === null">
                <div
                  class="field"
                  v-show="!auth">
                  <div class="kit info text block color yellow">
                    <p>
                      У вас есть <span class="kit text medium">промокод</span>?<br>
                      <a
                        class="link"
                        href="#"
                        @click.prevent="purchase.show = false;showAuthModal()">Авторизуйтесь</a>
                      и получите скидку.
                    </p>
                  </div>
                </div>
                <div
                  class="field"
                  :class="{ disabled: promoDisabled, invalid: !promo.valid, valid: promo.checked && promo.valid }">
                  <label>Промокод</label>
                  <div class="ui input fluid action">
                    <input
                      type="text"
                      v-model="promo.code"
                      :disabled="promoDisabled"
                      placeholder="Ваш код">
                    <button
                      type="button"
                      class="ui button yellow"
                      :class="{loading: promo.loading}"
                      @click.prevent="promoCodeCheck"
                      :disabled="promo.checked || promo.loading">Проверить
                    </button>
                  </div>
                  <div
                    class="error message"
                    v-show="!promo.valid">
                    <p>{{ promo.error }}</p>
                  </div>
                </div>
              </template>
              <div class="field">
                <div class="kit text center medium">
                  Стоимость полного отчета:
                  <template v-if="billing.checkauto.promocode">
                    <nobr>{{ billing.checkauto.promocode.price }}</nobr>
                  </template>
                  <template v-else>
                    <nobr> {{ price }} </nobr>
                  </template>
                </div>
              </div>
            </div>
          </div>
          <div class="actions without padding">
            <div class="footer not-top-padding">
              <AppButton
                class="ui yellow circular inmodal"
                :class="{ loading: flag.loading }"
                @click.native="paymentRequest"
                :disabled="actionDisabled || flag.loading">
                <div slot="button-item">
                  Перейти к оплате
                </div>
              </AppButton>
            </div>
          </div>
        </template>
      </CheckAutoModal>
    </div>

  </checkauto-layout>
</template>

<script>
import { mapState, createNamespacedHelpers } from 'vuex';
import { has, debounce, get } from 'lodash-es';

import CheckautoLayout from '~/components/redesign/check-auto/main-layout';
import Payment from '~/components/redesign/blocks/payment';
import Report from '~/components/redesign/check-auto/CheckAutoReport';
import PhoneInput from '~/components/blocks/phoneInput';
import Validator from '~/assets/js/validator';
import AppBreadcrumbs from '~/components/redesign/app-breadcrumbs';
import CheckAutoModal from '~/components/redesign/check-auto/checkauto-modal';
import AppButton from '~/components/redesign/app-buttons/app-button';
import AppCheckbox from '~/components/redesign/app-input/app-checkbox';

import { SHOW_AUTH_MODAL } from '~/assets/js/store/actionManager/mutation-types';
import { SHOW } from '~/assets/js/store/infoModal/action-types';
import SeoMixin from '~/assets/js/mixins/seo/base';
import SeoPageMixin from '~/assets/js/mixins/seo/pages/main/check-auto/report';

const STORE_ACTION_MANAGER = createNamespacedHelpers('actionManager');
const STORE_USER = createNamespacedHelpers('user');
const STORE_INFO_MODAL = createNamespacedHelpers('infoModal');

export default {
  name: 'ReportIdIndex',
  components: {
    AppBreadcrumbs,
    report: Report,
    'phone-input': PhoneInput,
    CheckautoLayout,
    Payment,
    CheckAutoModal,
    AppButton,
    AppCheckbox,
  },
  mixins: [SeoMixin, SeoPageMixin],
  asyncData({ app, params }) {
    return app.$axios.$get('/_main/checkauto/shortReportInfo', { params: { id: params.id } })
      .then(({ data }) => ({
        id: params.id,
        info: data.info,
        servicePrice: data.servicePrice,
        paymentSystem: data.paymentSystem,
      }))
      .catch(e => console.error(e));
  },
  data() {
    return {
      flag: {
        loading: false,
      },
      promo: {
        loading: false,
        code: '',
        checked: false,
        valid: true,
        noticeShow: false,
        error: '',
        price: null,
      },
      rawEmail: '',
      customer: {
        phone: '',
        email: '',
        agreement: false,
        registration: true,
      },
      purchase: {
        show: false,
      },
    };
  },
  asyncComputed: {
    emailAvailable() { // мыло доступно для регистрации(такого юзера еще нет)
      if (this.auth || !Validator.checkEmail(this.customer.email)) {
        return null;
      }

      return this.$axios.$get('/_main/user/get', { params: { username: this.customer.email } })
        .then(({ data }) => !has(data, 'id'))
        .catch((e) => {
          console.error(e);
          return false;
        });
    },
  },
  computed: {
    ...mapState(['billing']),
    ...STORE_USER.mapState(['auth']),
    dateNow() {
      const options = { year: 'numeric', month: '2-digit', day: '2-digit' };
      const today = new Date();

      return today.toLocaleDateString('ru-RU', options);
    },
    actionDisabled() {
      return !Validator.checkPhone(this.customer.phone)
            || !Validator.checkEmail(this.customer.email)
            || !this.customer.agreement;
    },
    promoDisabled() {
      return !Validator.checkEmail(this.customer.email)
            || (!this.auth && !this.customer.registration && this.emailAvailable);
    },
    price() {
      if (this.promo.price !== null) {
        return this.promo.price;
      }
      return this.servicePrice;
    },
    breadcrumbs() {
      return [
        {
          url: '/check-auto',
          name: 'Проверка авто',
        },
        {
          url: '',
          name: `${(this.info && this.info.Vin) ? this.info.Vin : ''}`,
        },
      ];
    },
  },
  watch: {
    rawEmail() {
      this.updateEmailDebounced();
    },
    promoDisabled(newVal) {
      if (newVal === true) {
        this.promo.code = '';
        this.promo.price = null;
      }
    },
    'promo.code'() {
      this.promo.checked = false;
      this.promo.valid = true;
      this.promo.price = null;
    },
  },
  created() {
    this.updateEmailDebounced = debounce(this.updateEmail, 200);
  },
  methods: {
    ...STORE_ACTION_MANAGER.mapMutations({
      showAuthModal: SHOW_AUTH_MODAL,
    }),
    ...STORE_INFO_MODAL.mapActions({
      showInfo: SHOW,
    }),
    updateEmail() {
      this.customer.email = this.rawEmail;
    },
    showPurchase() {
      // console.log(this.auth.chatRole);
      this.flag.loading = false;
      this.promo.loading = false;
      this.promo.code = '';
      this.promo.error = '';
      this.promo.valid = true;
      this.promo.checked = false;
      this.promo.price = null;
      this.customer.phone = this.auth ? get(this.auth, 'userProfile.phone', '') : '';
      this.customer.email = this.auth && this.auth.chatRole !== 'guest' ? this.auth.username : '';
      this.rawEmail = this.customer.email;
      this.purchase.show = true;
    },
    hidePurchase() {
      this.purchase.show = false;
    },
    paymentRequest() {
      this.flag.loading = true;
      let promocode = null;

      if (this.promo.code) {
        promocode = this.promo.code;
      } else if (this.billing.checkauto.promocode !== null) {
        promocode = this.billing.checkauto.promocode.code;
      }

      const emailAvailable = this.emailAvailable ? this.customer.registration : false;

      this.$axios.$post('/_main/checkauto/createPayment', {
        vinRequestDataId: this.id,
        email: this.customer.email,
        phone: this.customer.phone,
        register: this.auth ? false : emailAvailable,
        promocode,
      }).then(({ data }) => {
        if (data.report !== null) {
          this.hidePurchase();
          this.$router.push({ name: 'check-auto-full-report-id', params: { id: data.report } });
        } else if (data.payment !== null) {
          window.location.href = `/billing/process-payment/${data.payment}`;
        }
      }).catch((xhr) => {
        const { data } = xhr.response;
        if (has(data, 'message') && data.message) {
          this.showInfo({
            text: data.message,
            buttonVisible: false,
          });
        }
        console.error(xhr);
      }).finally(() => {
        this.hidePurchase();
        this.flag.loading = false;
      });
    },
    promoCodeCheck() {
      this.promo.loading = true;
      this.promo.error = '';
      this.promo.valid = true;
      this.promo.checked = false;
      this.promo.price = null;
      const params = {
        code: this.promo.code,
      };
      if (this.auth) {
        params.userId = this.auth.id;
      }
      this.$axios.$get('/_main/checkauto/promoCodeInfo', { params })
        .then(({ data }) => {
          console.log(JSON.stringify(data));
          this.promo.price = data.servicePrice;
        })
        .catch((xhr) => {
          const { data } = xhr.response;
          if (data.message) {
            this.promo.error = data.message;
          }
          this.promo.valid = false;
        })
        .finally(() => {
          this.promo.checked = true;
          this.promo.loading = false;
        });
    },
  },
};
</script>

<style scoped lang="postcss">
    .zIndex{
      z-index: 999;
    }
  .kit.view.checkauto.report {
    .top-button-wrap {
      @media only screen and (max-width: 375px) {
        flex-flow: column nowrap;
        align-items: flex-start;
        padding-top: 2.5rem;
        .text {
          padding-bottom: 0.5rem;
        }
      }
    }
    .kit.strike-text {
      position: relative;
      display: inline-block;
      &:after {
        content: attr(data-strike-text);
        position: absolute;
        top: calc(-100% - 0.625rem);
        text-align: center;
        background: #F37C7C;
        color: #fff;
        padding: 1px 6px;
        transform: translateX(-50%);
        margin-left: -50%;
        white-space: nowrap;
        font-weight: 700;
        line-height: 1.3;
      }
      &:before {
        content: '';
        position: absolute;
        width: 100%;
        right: 0;
        top: 50%;
        border: 1px solid #F37C7C;
      }
      &.right {
        margin-right: 5rem;
        &:after {
          top: 50%;
          transform: translateY(-50%);
          margin-left: 0.5rem;
        }
      }
      &.bottom {
        &:after {
          top: 100%;
        }
      }
    }
  }
</style>
